
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[Java] 集合框架的层次结构和使用规则梳理 / iVAN</title>

    <meta name="description" content="[Java] 集合框架的层次结构和使用规则梳理 在Java语言中,Java语言的设计者对常用的数据结构和算法做了一些规范(接口)和实现(具体实现接口的类).所有抽象出来的数据结构和操作(算法)统称为Java集合框架(JavaCollectionFramework). Java程序员在具体应用时,不必考虑数据结构和算法实现细节,只需要用这些类创建出来一些对象,然后直接应用就可以了,这样就大大提高了编程效率. 概述 什么是框架?  类库的集合 什么是集合? 存放数据的容器 集合框架用来干什么? 用来表示和操作的统一的架构 集合框架包含了两部分:一">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">[Java] 集合框架的层次结构和使用规则梳理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<blockquote><p>在<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">Java</a>语言中，Java语言的设计者对常用的<a href="http://lib.csdn.net/base/31" rel="external nofollow noreferrer">数据结构</a>和<a href="http://lib.csdn.net/base/31" rel="external nofollow noreferrer">算法</a>做了一些规范（接口）和实现（具体实现接口的类）。所有抽象出来的数据结构和操作（算法）统称为Java集合框架（JavaCollectionFramework）。</p>
<p>Java程序员在具体应用时，不必考虑数据结构和算法实现细节，只需要用这些类创建出来一些对象，然后直接应用就可以了，这样就大大提高了编程效率。</p></blockquote>
<h1>概述</h1>
<ul>
<li>什么是框架？ </li>
</ul>
<blockquote><p>类库的集合</p></blockquote>
<ul>
<li>什么是集合？</li>
</ul>
<blockquote><p>存放数据的容器</p></blockquote>
<ul>
<li>集合框架用来干什么？</li>
</ul>
<blockquote><p>用来表示和操作的统一的<a href="http://lib.csdn.net/base/16" rel="external nofollow noreferrer">架构</a></p></blockquote>
<p>集合框架包含了两部分：一部分是类，一部分是接口（用来规范相似功能的类）</p>
<p>主要结构图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjcxNTUzMjE4MzM=.jpg">　</p>
<p>　　Java集合工具包位于Java.util包下，包含了很多常用的数据结构，如数组、链表、栈、队列、集合、哈希表等。　 <br />
 <br />
Java集合框架的使用重点：List列表、Set集合、Map映射、迭代器（Iterator、Enumeration）、工具类（Arrays、Collections）。　</p>
<h1>Collection</h1>
<p>　　 Collection是List、Set等集合高度抽象出来的接口，它包含了这些集合的基本操作，实现该接口及其子接口的所有类都可应用clone()方法，并是序列化类。 <br />
 <br />
主要实现关系层次图：　</p>
<p>　　　<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjcxNTU5MzY4MTY=.jpg">　</p>
<p>Collection的常用方法：</p>
<ul>
<li>添加 <br />
boolean add(E e); <br />
boolean addAll(Collection&lt;&gt; c)　　</li>
<li>删除 <br />
boolean remove(E e); <br />
boolean removeAll(Collection&lt;&gt; c) ; <br />
void clear();</li>
<li>判断 <br />
boolean contains(Object o) <br />
boolean containsAll(Collection&lt;&gt; c) <br />
boolean isEmply();</li>
<li>获取 <br />
int size(); <br />
Iterator iterator();</li>
<li>其他 <br />
boolean retainAll(Collection coll); <br />
Object[] toArray();　　</li>
</ul>
<h2>List</h2>
<p>　　List接口通常表示一个列表，<strong>可随机访问</strong>包含的元素，元素是<strong>有序的</strong>，可在任意位置增、删元素，不管访问多少次，元素位置不变，<strong>允许重复</strong>元素。　<br />
 <br />
用Iterator实现单向遍历，也可用ListIterator实现双向遍历。</p>
<p>List特有的常见方法：</p>
<ul>
<li>添加 <br />
void add(index,element); <br />
void add(index,collection);</li>
<li>删除 <br />
Object remove(index);</li>
<li>获取 <br />
Object get(index); <br />
int indexOf(object); <br />
int lastIndexOf(object); <br />
Last subList(from,to);</li>
<li>修改 <br />
Object set(index,element);</li>
</ul>
<h3>LinkedList</h3>
<p>　　内部是<strong>链表</strong>数据结构，<strong>随机访问很慢</strong>，<strong>增删操作很快</strong>，不耗费多余资源，<strong>允许null元素</strong>，<strong>非线程安全</strong> ．如果多个线程同时访问一个List，则必须自己实现访问同步。 　　　　</p>
<pre><code>List list = Collections.synchronizedList(new LinkedList(...));</code>
</pre>
<h3>ArrayList</h3>
<p>　　内部是<strong>数组</strong>数据结构，元素顺序存储。新增元素改变List大小时，内部会新建一个数组，在将添加元素前将所有数据拷贝到新数组中 。<strong>随机访问很快</strong>，<strong>删除非头尾元素慢，新增元素慢</strong>而且费资源 。较适用于无频繁增删的情况，可增长数组，50%延长。比数组效率低，如果不是需要可变数组，可考虑使用数组，<strong>非线程安全</strong>。</p>
<h3>Vector</h3>
<p>　　另一种ArrayList，具备ArrayList的特性。所有方法都是<strong>线程安全</strong>的（双刃剑，和ArrayList的主要区别） 比ArrayList效率低。</p>
<h4>Stack</h4>
<p>　　LIFO的数据结构，Stack继承自Vector，也是<strong>同步的</strong>。</p>
<h2>Set</h2>
<p>　　通常表示一个集合，接口中的方法和Collection中的一致。是一个不允许重复元素的Collection，<strong>可以有一个空元素</strong>，<strong>不可随机</strong>访问包含的元素，只能用Iterator实现单向遍历，Set**不同步**。</p>
<h3>HashSet</h3>
<p>　　内部数据结构是哈希表（HashMap），元素是<strong>无序的</strong>，迭代访问元素的顺序和加入的顺序不同 .多次迭代访问，元素的顺序可能不同，<strong>非线程安全</strong>。</p>
<h4>LinkedHashSet</h4>
<p>　　基于HashMap和链表的Set实现，迭代访问元素的顺序和加入的顺序相同，多次迭代访问，元素的<strong>顺序不变</strong>。</p>
<h3>SortedSet</h3>
<p>　　加入SortedSet的所有元素必须实现Comparable接口，元素是<strong>有序的</strong>。</p>
<h4>TreeSet</h4>
<p>　　基于TreeMap实现的SortedSet，可以对Set集合中的元素进行排序，排序后按<strong>升序</strong>排列元素，<strong>非线程安全</strong>。 <br />
 <br />
两种排序方式：</p>
<ul>
<li>让元素自身具备比较功能，<strong>元素</strong>就需要实现Compareable方法覆盖compareTo方法。</li>
<li>让集合自身具备比较功能，定义一个类实现Comparator接口，覆盖compare方法。</li>
</ul>
<h1>Map</h1>
<p>　　是一个映射接口，Map没有继承Collection接口，Map提供key到value的映射。一个Map中不能包含相同的key，每个key只能映射一个value。　 <br />
 <br />
抽象类AbstractMap通过适配器模式实现了Map接口中的大部分函数，TreeMap、HashMap、WeakHashMap等实现类都通过继承AbstractMap来实现，但不常用的HashTable直接实现了Map接口。　</p>
<p>　　实现关系层次图：　</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjcxNjMyNTQ2NDI=.jpg">　</p>
<p>map中常用的方法：</p>
<ul>
<li>添加 <br />
value put(key,value):返回前一个和key关联的值，如果没有则返回null</li>
<li>删除 <br />
void clear():清空map集合。 <br />
value remove(key):根据指定的key删除这个键值对</li>
<li>判断 <br />
boolean containKey(key) <br />
boolean containValue(value) <br />
boolean isEmpty();</li>
<li>获取 <br />
value get(key);通过键获取值，如果没有该键返回null，当然可以通过返回null来判断是否包含指定键 <br />
int size()获取键值对个数。</li>
</ul>
<p>取出Map集合中的所有值的方法：</p>
<ul>
<li>通过keySet方法获取map中所有的键所在的Set集合，再通过Set的迭代器获取到每一个键，再对每一个键获通过map集合的get方法取其对应值即可。　</li>
</ul>
<pre><code>        Map map = new LinkedHashMap();
        map.put("1", "第一个数");
        map.put("2", "第二个数");
        map.put("3", "第三个数");
        for (Object obj : map.keySet()) {
            String key = (String) obj;
            String value = (String) map.get(key);
        }</code>
</pre>
<ul>
<li>通过map集合的entryset方法也可取出map集合当中所有的键值对，返回的就是Map.Entry对象，再通过Map.Entry对象的getkey和getvalue方法就可以取出对应的键和值。　</li>
</ul>
<pre><code>        Map map = new LinkedHashMap();
        map.put("1", "one");
        map.put("2", "two");
        map.put("3", "three");
        for (Object obj : map.entrySet()) {
            Entry entry = (Entry) obj;
            String key = (String) entry.getKey();
            String value = (String) entry.getValue();
        }</code>
</pre>
<ul>
<li>通过Iterator遍历keySet或entryset</li>
</ul>
<pre><code>        Map map = new HashMap();
        map.put("1", "one");
        map.put("2", "two");
        map.put("3", "three");
        Set set = map.keySet();
        Iterator it = set.iterator();
        while (it.hasNext()) {
            String key = (String) it.next();
            String value = (String) map.get(key);
        }</code>
</pre>
<pre><code>        Map map = new HashMap();
        map.put("1", "one");
        map.put("2", "two");
        map.put("3", "three");
        Set set = map.entrySet();
        Iterator it = set.iterator();
        while (it.hasNext()) {
            Entry entry = (Entry) it.next();
            String key = (String) entry.getKey();
            String value = (String) entry.getValue();
        }</code>
</pre>
<h2>Hashtable</h2>
<p>　　用作键的对象必须实现了hashcode()、equals()方法，也就是说只有Object及其子类可用作键，Hashtable继承于Dictionary字典，实现Map接口。<strong>键、值都不能是空对象</strong>，多次访问，映射元素的<strong>顺序相同</strong> ，<strong>线程安全</strong>。</p>
<h3>Properties</h3>
<p>　　继承于Hashtable，<strong>键和值都是字符串</strong>。</p>
<h2>HashMap</h2>
<p>　　内部结构是哈希表，<strong>键和值都可以是空对象，不保证映射的顺序</strong>，多次访问，映射元素的顺序可能不同，<strong>非线程安全</strong>。　</p>
<h3>LinkedHashMap</h3>
<p>　　继承于HashMap ，多次访问，映射元素的<strong>顺序是相同的</strong>，性能比HashMap差。</p>
<h2>WeakHashMap</h2>
<p>　　当某个键不再正常使用时，垃圾收集器会移除它，即便有映射关系存在，<strong>非线程安全</strong>。</p>
<h2>SortedMap</h2>
<p>　　键按<strong>升序</strong>排列，所有键都必须实现Comparable接口。</p>
<h3>TreeMap</h3>
<p>　　内部结构是二叉树（基于红黑树实现），<strong>不同步</strong>，可以对Map集合中的键进行排序。</p>
<h1>Iterator</h1>
<p>　　Iterator是遍历<strong>集合</strong>的迭代器（不能遍历Map，只用来遍历Collection），Collection的实现类都实现了iterator()函数，它返回一个Iterator对象。　 <br />
 <br />
ListIterator则专门用来遍历List。　 <br />
而Enumeration则是JDK1.0时引入的，作用与Iterator相同，但它的功能比Iterator要少，它只能在Hashtable、Vector和Stack中使用。</p>
<p>　　Arrays和Collections是用来操作数组、集合的两个工具类。</p>
<h1>使用技巧</h1>
<ul>
<li>需要<strong>唯一</strong>用Set <br />
且需要指定顺序：TreeSet <br />
不需要：HashSet　 <br />
 <br />
得到与存储一致的顺序：LinkedHashSet　 </li>
<li>不需要<strong>唯一</strong>用List <br />
需要频繁增删动作用：LinkedList <br />
不需要：ArrayList　 </li>
<li>如果涉及到堆栈、队列等操作，应该考虑用List；</li>
<li>对于需要快速插入，删除元素，应该使用LinkedList；</li>
<li>如果需要快速随机访问元素，应该使用ArrayList。</li>
<li>如果程序在单线程环境中，或者访问仅仅在一个线程中进行，考虑非同步的类，其效率较高。</li>
<li>如果多个线程可能同时操作一个类，应该使用同步的类。 要特别注意对哈希表的操作，作为key的对象要正确复写equals和hashCode方法。 尽量返回接口而非实际的类型，如返回List而非ArrayList，这样如果以后需要将ArrayList换成LinkedList时，客户端代码不用改变，这就是针对抽象编程。</li>
</ul>
<p>版权声明：请尊重个人劳动成果，转载注明出处，谢谢！</p>
<p>http://my.csdn.net/Amazing7</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 19:00:07</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java%e9%9b%86%e5%90%88%e6%a1%86%e6%9e%b6/" title="java集合框架">java集合框架</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>[Java] 集合框架的层次结构和使用规则梳理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rnLgz.html" rel="bookmark">Java集合框架实现自定义排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java集合框架针对不同的数据结构提供了多种排序的方法,虽然很多时候我们可以自己实现排序,比如数组等,但是灵活的使用JDK提供的排序方法,可以提高开发效率,而且通常JDK的实现要比自己造的轮子性能更优化. 1.使用Arrays对数组进行排序 Java API对Arrays类的说明是:此类包含用来操作数组(比如排序和搜索)的各种方法. (1)使用Arrays排序 Arrays使用非常简单,直接调用sort()即可: 1 2 3 4 5 6 7 8 9 10 11 int[] arr = new i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bodRggM.html" rel="bookmark">Java集合框架：HashMap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java集合框架概述   Java集合框架无论是在工作.学习.面试中都会经常涉及到,相信各位也并不陌生,其强大也不用多说,博主最近翻阅java集合框架的源码以及搜索一些相关资料整理出Java集合框架的系列.一方面是做一个总结,方便以后查阅,另一方面希望各位小伙伴能够提出不足之处,我会及时更新修改.   博主从网上抠了一张图,觉得画得还是比较形象的,给大家参考一下.   上述类图中,实线边框的是实现类,比如ArrayList,LinkedList,HashMap等,折线边框的是抽象类,比如Abst			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boL3vVM.html" rel="bookmark">关于Java集合框架面试题（含答案）上&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Java集合框架是什么?说出一些集合框架的优点? 每种编程语言中都有集合,最初的Java版本包含几种集合类:Vector.Stack.HashTable和Array.随着集合的广泛使用,Java1.2提出了囊括所有集合接口.实现和算法的集合框架.在保证线程安全的情况下使用泛型和并发集合类,Java已经经历了很久.它还包括在Java并发包中,阻塞接口以及它们的实现.集合框架的部分优点如下: (1)使用核心集合类降低开发成本,而非实现我们自己的集合类. (2)随着使用经过严格测试的集合框架类,代			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvEn51b.html" rel="bookmark">Java集合框架List，Map，Set等全面介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java Collections Framework是Java提供的对集合进行定义,操作,和管理的包含一组接口,类的体系结构.   Java集合框架的基本接口/类层次结构: java.util.Collection [I]+--java.util.List [I]   +--java.util.ArrayList [C]   +--java.util.LinkedList [C]   +--java.util.Vector [C]      +--java.util.Stack [C]+--ja			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQ8Kzq.html" rel="bookmark">Java集合源码剖析：Java集合框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java集合工具包位于Java.util包下,包含了很多常用的数据结构,如数组.链表.栈.队列.集合.哈希表等.学习Java集合框架下大致可以分为如下五个部分:List列表.Set集合.Map映射.迭代器(Iterator.Enumeration).工具类(Arrays.Collections). Java集合类的整体框架如下: 从上图中可以看出,集合类主要分为两大类:Collection和Map. Collection是List.Set等集合高度抽象出来的接口,它包含了这些集合的基本操作,它主			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvY0rb.html" rel="bookmark">JAVA集合框架之List接口实现类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇博客&lt;JAVA集合框架之Set接口实现类&gt;中介绍了Set接口的相关实现类,这一篇将介绍List接口的实现类. java.util.ArrayList&lt; E &gt; ArrayList有点类似于数组,相比较于数组而言,ArrayList可以动态的更改元素个数,相对于数组较为灵活. 每个 ArrayList 实例都有一个容量.该容量是指用来存储列表元素的数组的大小.它总是至少等于列表的大小.随着向 ArrayList 中不断添加元素,其容量也自动增长.并未指定增长策略的细节,因为这不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrx0mz.html" rel="bookmark">java集合框架中List的定义及注意事项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家知道,集合框架是为了表示和操作集合而规定的一种统一的标准的体系结构,学习集合知识有利于我们解决一系列例如保存数据与对象的问题. 常用的集合在系统中定义了两大接口,List和Set 这里我们就来讨论一下List 的定义以及一些常见的问题 List定义的是有序的并且数据可以重复的集合,我们先看一下下面这段代码: import java.util.ArrayList; import java.util.List; publicclass ListTest{ publicstaticvoid mai			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkqm6b.html" rel="bookmark">java &vert; 集合框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				集合框架 集合代表了一组对象,Java中的集合框架定义了一套规范,用来表示.操作集合,使具体操作与实现细节解耦. 而这些操作无非就是增.删.改.查! 集合和数组的区别: 1.数组的长度固定,集合长度可变. 2.数组只能存储相同类型的数据(基本类型/引用类型),集合可存储各种类型的数据. Java集合框架接口 Java集合框架的顶层接口包括: 一.Collection接口: 1.实现Collection接口的集合有List.Set.Queue(Java队列实现). 2.List:排列有序,可以有重			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmQR8z.html" rel="bookmark">java基础-学到java集合框架中对那个复写equals的疑问，求解答</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 学到java集合框架中对那个复写equals的疑问,求解答 import java.util.*; class Student implements Comparable { private String name; private int age; Student(String name,int age) { this.name = name; this.age = age; } public int compareTo(Student s) { int num = new Inte			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjZYdb.html" rel="bookmark" class="title">扬扬的J2EE学习笔记（五）Installing J2EE SDK（安装J2EE SDK）</a>
					<div>
						j2ee|笔记 每周学一些J2EE,作点笔记. 目标:能熟练使用Websphere做J2EE的开发工作. 加油!加油!!加油!!! 以在Linux下安装为例. 1 准备安装J2SE普通用户身份:./j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgA85z.html" rel="bookmark" class="title">PHP的可变变量名介绍</a>
					<div>
						有时候可变的变量名会给编程带来很大的方便.也就是说变量名可以被动态的命名和使用.通常变量通过下面这样的语句来命名 : &lt;?php $a = &quot;hello&quot;; ?&gt;  可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNkqvb.html" rel="bookmark" class="title">linux web服务器的几个案例</a>
					<div>
						案例一 1.要求实现基于主机头的虚拟主机,IP均为192.168.1.25 2.主站点为www.abc.com,主目录为/var/www/html,任何人都能访问: 3.市场部站点为mkt.abc.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKxP1p.html" rel="bookmark" class="title">Linux网络配置的基础配置</a>
					<div>
						1 linux网络配置介绍 网络是属于内核的功能,给linux的 主机网卡配置地址的时候,地址是属于内核的,而不是网卡 1.1 DNS 解析其他主机的主机名.一般需要两个,另一个备用(备用DNS的使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62m9AM.html" rel="bookmark" class="title">调用iphone地图、电话、邮件、短信及内容方法</a>
					<div>
						代码如下 -(IBAction)openMaps { // Where is Apple on the map anyway? NSString* addressText = @&quot;1 Inf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7O7wb.html" rel="bookmark" class="title">Access 2000建立一个空的数据库</a>
					<div>
						  既然已经了解了在建立一个数据库之前应该注意的问题,那我们现在就从最基本的新建一个空数据库开始,了解一下Access数据库的结构. 在Access 2000中,新建一个空数据库其实很简单,只要用鼠标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPQAOM.html" rel="bookmark" class="title">Excel2007添加单元格批注</a>
					<div>
						Excel2007添加单元格批注 如果有一些文档来解释工作表中的某些元素常常会很有帮助.一种方法是向单元格添加批注.当需要描述一个特殊的值或解释公式怎样运算时,这一功能就显得非常有用. 要向一个单元格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwQGQz.html" rel="bookmark" class="title">如何监控MySQL性能？</a>
					<div>
						  一,获取mysql用户下的进程总数 ps -ef | awk '{print $1}' | grep &quot;mysql&quot; | grep -v &quot;grep&quot; |  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balOgqz.html" rel="bookmark" class="title">提高内存使用效能的几种好方法</a>
					<div>
						如何优化内存的管理,提高内存的使用效率,尽可能地提高运行速度,是我们所关心的问题.下面介绍在Windows操作系统中,提高内存的使用效率和优化内存管理的几种方法. 方法一:调整高速缓存区域的大小 可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNo1mb.html" rel="bookmark" class="title">ps打造粉色绒毛字技巧</a>
					<div>
						最终效果 1.新建文档,大小随意,选择文字工具,打上你想要的文字,颜色用黑色,双击图层设置图层样式,如下: &lt;内阴影参数&gt; &lt;斜面和浮雕参数&gt; &lt;颜色叠加参数&gt; 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oOjab.html" rel="bookmark" class="title">使用photoshop来设计自己的简历封面</a>
					<div>
						  每到大学生找工作的日子,大家都在忙着做自己的求职简历,在制作简历时不仅文才要好,而且&quot;美工&quot;也要好,可以设想如果精彩的文字再加上一个漂亮的封面肯定会在众多的应聘者中脱颖而出,提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYReNxp.html" rel="bookmark" class="title">Windows XP电脑入门&colon;汉字输入</a>
					<div>
						  输入法有专门的程序,图标在任务栏的右下角,一个键盘 的图标,点击后显示安装的输入法; 最上面的&quot;中文(中国)&quot;是英文输入,下面两个彩色的是汉字输入; 选中汉字输入法后,会出来一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywVlvz.html" rel="bookmark" class="title">网络-提问一下路由器和交换机的连接的问题</a>
					<div>
						问题描述 提问一下路由器和交换机的连接的问题 如图,路由器r1和r2之间连着一个交换机sw1 s1端口ip是192.168.1.1,s2端口ip是192.168.1.2,交换机sw1该怎么配置才能使两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6Oy6b.html" rel="bookmark" class="title">电脑内存条价格一年涨幅超两倍</a>
					<div>
						记者昨天从重庆电脑市场了解到,春节至今电脑内存价格一直持续上涨,尤其是最近一周更是加速上扬,涨幅较一周前接近20%.但这还不算猛的,如果拿去年此时和现在比较,内存条价格已涨了两倍多.如此惊人的价格涨幅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myw5yZz.html" rel="bookmark" class="title">regex-使用pattern查找文件（正则表达式）</a>
					<div>
						问题描述 使用pattern查找文件(正则表达式) 在文件夹中的文件: myfile_mark_1.mp4 myfile_john_2.mp4 myfile_jake_3.mp4 myfile_tri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kZ2oM.html" rel="bookmark" class="title">Python风靡全宇宙，首要原因竟是它？</a>
					<div>
						众所周知,Python是目前使用最广泛且用户增长最快的编程语言.优雅简洁的语法.强大的第三方库支持等都是Python能够风靡各行各业的原因.然而,你或许不知道,Python能够实现用户飞速增长,背后其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6qm8b.html" rel="bookmark" class="title">搜索引擎页面去重算法分析之I-Match算法</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 互联网中存在了大量的重复页面,据统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEV82z.html" rel="bookmark" class="title">javascript-js改变文本框的value，什么事件能捕获到文本框内容的改变</a>
					<div>
						问题描述 js改变文本框的value,什么事件能捕获到文本框内容的改变 文本框的value是由js改变的,什么事件能捕获到文本框内容的改变. 我查到onpropertychange但是只适合IE浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGADe6M.html" rel="bookmark" class="title">while&lpar;~scanf&lpar;&amp;amp&semi;quot&semi;&percnt;d&percnt;d&amp;amp&semi;quot&semi;&comma;&amp;amp&semi;amp&semi;n&comma;&amp;amp&semi;amp&semi;m&rpar;&rpar; &lbrace;&period;&period;&period;&rcub;</a>
					<div>
						每次在A题的时候,都会碰到用 while(scanf(&quot;%d%d&quot;,&amp;n,&amp;m)!=EOF) {...} 来判断结束标志的 用while(~scanf(&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7qDWz.html" rel="bookmark" class="title">html5多出来的字自动隐藏并显示&period;&period;&period;</a>
					<div>
						   					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEZ0OM.html" rel="bookmark" class="title">JAVA语言学校的危险性</a>
					<div>
						下面的文章是More Joel on Software一书的第8篇.                                我觉得翻译难度很大,整整两个工作日,每天8小时以上,才译出了5000 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1LWNz.html" rel="bookmark" class="title">深度学习洪流：为何它能瞬间改变你的生活？ （下）</a>
					<div>
						tech2ipo 编者按:我们和电脑之间的交流正在发生着转变,而深度学习也已经润物细无声地进入我们的生活,甚至在你意识到这一点之前,世界已经截然不同. 本文首发于 fortune,分上下篇,由老吕IO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRlgZb.html" rel="bookmark" class="title">ccccc-ofbiz自动生成id编号gggg</a>
					<div>
						问题描述 ofbiz自动生成id编号gggg 在ofbiz里,如何通过xml文件直接生成id编号,不经过任何Java代码,非常急,请指教 解决方案 这东西好像得用ofbiz迷你语言吧,时间长了,记不清 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqyoVp.html" rel="bookmark" class="title">zend studio代码自动提示问题，有的提示正常有的提示不正常，解决方法</a>
					<div>
						经过试验此类问题都是有备注中@reuturn 类名 有关 @return PositionData the static model class 加入这个类名后,代码自动提示即可正常 案例: clas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xZ6Rb.html" rel="bookmark" class="title">ajax传值（form表单）</a>
					<div>
						问题描述 ajax传值(form表单) 我想用ajax将一个form表单传递给servlet.各位,能否实现?? 解决方案 jQuery $.post(url, $('form').serialize ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXKABb.html" rel="bookmark" class="title">蚂蚁金服与阿里云宣布启动&OpenCurlyDoubleQuote;蚂云计划&rdquo;</a>
					<div>
						蚂蚁金服与阿里云宣布启动&quot;蚂云计划&quot; 10月13日下午消息,在2016杭州云栖大会上,蚂蚁金服首席技术官程立宣布启动&quot;蚂云计划&quot;,未来服务全球5万家金融机构.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8mJ8p.html" rel="bookmark" class="title">360已将综合搜索默认设置为首选搜索引</a>
					<div>
						上周四,奇虎360的通用搜索产品so.360.cn对外曝光,核心则是综合搜索.仅过去5天,就在昨日晚间,在360安全网址导航,360已将综合搜索默认设置为首选搜索引擎.此外,360安全浏览器的搜索栏, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWEm2z.html" rel="bookmark" class="title">最新土豆&sol;乐视&sol;优酷会员账号8月6日分享</a>
					<div>
						乐视免费会员账号分享8月6日更新 账号:13790507156密码:6457732 账号:13335716009密码:who451392 账号:13439794375密码:qq521521 账号:13 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NX5Bb.html" rel="bookmark" class="title">actionbar-android 中 ActionBar 的相关问题</a>
					<div>
						问题描述 android 中 ActionBar 的相关问题 我使用下面的代码显示 action bar: setTheme(android.R.style.Theme_WithActionBar); ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKWvlz.html" rel="bookmark" class="title">谈谈对产品运营思路的理解</a>
					<div>
						一直做产品,从未做运营,但这并不妨碍我谈谈对运营的理解.因为在互联网领域,产品和运营都是相通的,产品是要给用户提供价值,运营是让用户认识这种价值,它们相互依存,战略目标是一致的.任何运营都围绕&quo ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
